require "spec_helper"

RSpec.describe XpRubyClient do
  before(:each) do
    ENV["XP_RUBY_CLIENT_HOST"] = "http://localhost:5000"
    @empty_resp = OpenStruct.new({body: JSON.dump({"unassign"=>[], "assign"=>[]}), status: 200})
  end

  it "returns experiments" do
    expect_any_instance_of(Patron::Session).to receive(:post).and_return(@empty_resp)
    req = described_class.experiment do |config|
      config.application = "web"
      config.timeout = 30
    end
    expect(req.retrieve).to eq(JSON.parse(@empty_resp.body))
  end

  it "returns nil when timeout is reached" do
    expect_any_instance_of(Patron::Session).to receive(:post) do
      sleep 0.2
    end
    req = described_class.experiment do |config|
      config.application = "web"
      config.timeout = 1
    end
    expect(req.retrieve).to be_nil
  end
end
